#include "stc.h"
#include "usb.h"

#include "HC595.h"
#include "SMG_LED.h"
#include "TIM0.h"
#include "KEY.h"
#include "Beep.h"
#include "exit.h"



#define MAIN_Fosc 24000000UL	//ʱ

//USBԼλ趨
char *USER_DEVICEDESC = NULL;
char *USER_PRODUCTDESC = NULL;
char *USER_STCISPCMD = "@STCISP#";   //ԶλISPûӿ

bit  TIM0_10MS_FLAG =  0;    /* ʱ0 10msʱʱ״̬־λ */

u16  Warning_TimeCount = 0;  /* ɿťļֵ */

void sys_init()
{
    WTST = 0;  //óָʱֵΪ0ɽCPUִָٶΪ
    EAXFR = 1; //չĴ(XFR)ʹ
    CKCON = 0; //߷XRAMٶ

    P0M1 = 0x00;   P0M0 = 0x00;   //Ϊ׼˫
    P1M1 = 0x00;   P1M0 = 0x00;   //Ϊ׼˫
    P2M1 = 0x00;   P2M0 = 0x00;   //Ϊ׼˫
    P3M1 = 0x00;   P3M0 = 0x00;   //Ϊ׼˫
    P4M1 = 0x00;   P4M0 = 0x00;   //Ϊ׼˫
    P5M1 = 0x00;   P5M0 = 0x00;   //Ϊ׼˫
    P6M1 = 0x00;   P6M0 = 0x00;   //Ϊ׼˫
    P7M1 = 0x00;   P7M0 = 0x00;   //Ϊ׼˫
    
	P3M0 &= ~0x03;
    P3M1 |= 0x03;
	
    //USBʹõʱԴ
    IRC48MCR = 0x80;    //ʹڲ48MIRC
    while (!(IRC48MCR & 0x01));  //ȴʱȶ
	
	USBCLK = 0x00;     //ʹCDCҪʹУHIDܴʱֹʹ
    USBCON = 0x90;
}

void main()
{
	u8 matrix_KeyValue = 0;
	u8 LED_State = 0xFF;
	
	sys_init();
    usb_init();     //USBʼ
	
	SMG_LED_Init();  /* LEDĳʼ */
	BEEP_Init();     /* ʼ */
	Timer0_Init();   /* ʱ0ʼ */
	P3_Exit_Init();  /* P3˿жϳʼ */
	
    EA = 1;    /* ж */
	
	while(1)
	{                     
		if(DeviceState != DEVSTATE_CONFIGURED)  /* жUSBǷӳɹ */
			continue;
		if(bUsbOutReady)    
		{
			usb_OUT_done();
		}
		
		if(TIM0_10MS_FLAG) /* ÿ10msһ */
		{
			TIM0_10MS_FLAG = 0;  /* 10msʱ־λ */
			BEEP_RUN();          /* ·״̬ */
			
			if(Warning_TimeCount == 0)                            /* ťûб */
			{
				matrix_KeyValue = Matrix_KEY_Read();              /* ȡֵ̰ */
				if((matrix_KeyValue>0) && (matrix_KeyValue <9 ))  /* 1-8 */
				{
					LED_State ^= (1<<(matrix_KeyValue-1));              /* ͬΪ0ͬΪ1 */
				}
				LED = LED_State;
				SEG0 = 21;                                        /* ر */         
			}
			else                          /* ťɿ */
			{
				Warning_TimeCount--;
				SEG0 = (Warning_TimeCount/100)+1;
				
			}
			
			
		}
	}
}

/*******************************************************************************
*  : Timer0_Isr
*  : ʱ0жϷ
* ڲ : 
*  : 
* ע : ÿ1msһжϷ
*******************************************************************************/
void Timer0_Isr(void) interrupt 1   
{
	static u16 Time_Count = 0;
	
	Time_Count++;
	
	if(Time_Count>=10)
	{
		Time_Count = 0;
		TIM0_10MS_FLAG = 1;
	}
	SMG_LED_Show();  /* ÿ1msһLEDˢ */
}



/*******************************************************************************
*  : P3_Exit_Isr
*  : P3˿ڵжϷ
* ڲ : 
*  : 
* ע : 
*******************************************************************************/
void P3_Exit_Isr(void) interrupt 40     // P3˿ڵжϷһʹõʱ򶼷main.cļ
{
	u8 intf; 
	intf = P3INTF;    // ȡжϱ־λ 
	if(intf)
	{
		P3INTF = 0;   //жϱ־λ
		if(intf & (1<<5))  // P35ж
		{
			LED = 0x00;               /*  */
			SEG0 = 5;
			Warning_TimeCount = 500;
		}
	}
}











